/**
 * @license
 * Copyright (c) 2020 Handsoncode. All rights reserved.
 */
// import
export var dictionary = {
  errors: {
    CYCLE: '#CYCLE!',
    DIV_BY_ZERO: '#¡DIV/0!',
    ERROR: '#ERROR!',
    NA: '#N/D',
    NAME: '#¿NOMBRE?',
    NUM: '#¡NUM!',
    REF: '#¡REF!',
    VALUE: '#¡VALOR!'
  },
  functions: {
    ABS: 'ABS',
    ACOS: 'ACOS',
    ACOSH: 'ACOSH',
    ACOT: 'ACOT',
    ACOTH: 'ACOTH',
    AND: 'Y',
    ASIN: 'ASENO',
    ASINH: 'ASENOH',
    ATAN2: 'ATAN2',
    ATAN: 'ATAN',
    ATANH: 'ATANH',
    AVERAGE: 'PROMEDIO',
    AVERAGEA: 'PROMEDIOA',
    AVERAGEIF: 'PROMEDIO.SI',
    BASE: 'BASE',
    BIN2DEC: 'BIN.A.DEC',
    BIN2HEX: 'BIN.A.HEX',
    BIN2OCT: 'BIN.A.OCT',
    BITAND: 'BITAND',
    BITLSHIFT: 'BITLSHIFT',
    BITOR: 'BITOR',
    BITRSHIFT: 'BITRSHIFT',
    BITXOR: 'BITXOR',
    CEILING: 'MULTIPLO.SUPERIOR',
    CHAR: 'CARACTER',
    CHOOSE: 'ELEGIR',
    CLEAN: 'LIMPIAR',
    CODE: 'CODIGO',
    COLUMN: 'COLUMNA',
    COLUMNS: 'COLUMNAS',
    CONCATENATE: 'CONCATENAR',
    CORREL: 'COEF.DE.CORREL',
    COS: 'COS',
    COSH: 'COSH',
    COT: 'COT',
    COTH: 'COTH',
    COUNT: 'CONTAR',
    COUNTA: 'CONTARA',
    COUNTBLANK: 'CONTAR.BLANCO',
    COUNTIF: 'CONTAR.SI',
    COUNTIFS: 'CONTAR.SI.CONJUNTO',
    COUNTUNIQUE: 'COUNTUNIQUE',
    CSC: 'CSC',
    CSCH: 'CSCH',
    CUMIPMT: 'PAGO.INT.ENTRE',
    CUMPRINC: 'PAGO.PRINC.ENTRE',
    DATE: 'FECHA',
    DATEDIF: 'DATEDIF',
    DATEVALUE: 'FECHANUMERO',
    DAY: 'DIA',
    DAYS360: 'DIAS360',
    DAYS: 'DÍAS',
    DB: 'DB',
    DDB: 'DDB',
    DEC2BIN: 'DEC.A.BIN',
    DEC2HEX: 'DEC.A.HEX',
    DEC2OCT: 'DEC.A.OCT',
    DECIMAL: 'CONV.DECIMAL',
    DEGREES: 'GRADOS',
    DELTA: 'DELTA',
    DOLLARDE: 'MONEDA.DEC',
    DOLLARFR: 'MONEDA.FRAC',
    EDATE: 'FECHA.MES',
    EFFECT: "INT.EFECTIVO",
    EOMONTH: 'FIN.MES',
    ERF: 'FUN.ERROR',
    ERFC: 'FUN.ERROR.COMPL',
    EVEN: 'REDONDEA.PAR',
    EXACT: 'IGUAL',
    EXP: 'EXP',
    FALSE: 'FALSO',
    FIND: 'ENCONTRAR',
    FORMULATEXT: 'FORMULATEXTO',
    FV: 'VF',
    FVSCHEDULE: 'VF.PLAN',
    HEX2BIN: 'HEX.A.BIN',
    HEX2DEC: 'HEX.A.DEC',
    HEX2OCT: 'HEX.A.OCT',
    HLOOKUP: 'BUSCARH',
    HOUR: 'HORA',
    IF: 'SI',
    IFERROR: 'SI.ERROR',
    IFNA: 'IFNA',
    INDEX: 'INDICE',
    INT: 'ENTERO',
    INTERVAL: 'INTERVAL',
    IPMT: 'PAGOINT',
    ISBINARY: 'ISBINARY',
    ISBLANK: 'ESBLANCO',
    ISERR: 'ESERR',
    ISERROR: 'ESERROR',
    ISEVEN: 'ES.PAR',
    ISFORMULA: 'ISFORMULA',
    ISLOGICAL: 'ESLOGICO',
    ISNA: 'ESNOD',
    ISNONTEXT: 'ESNOTEXTO',
    ISNUMBER: 'ESNUMERO',
    ISODD: 'ES.IMPAR',
    ISOWEEKNUM: 'ISOWEEKNUM',
    ISPMT: 'INT.PAGO.DIR',
    ISREF: 'ESREF',
    ISTEXT: 'ESTEXTO',
    LEFT: 'IZQUIERDA',
    LEN: 'LARGO',
    LN: 'LN',
    LOG10: 'LOG10',
    LOG: 'LOG',
    LOWER: 'MINUSC',
    MATCH: 'COINCIDIR',
    MAX: 'MAX',
    MAXA: 'MAXA',
    MAXPOOL: 'MAXPOOL',
    MEDIAN: 'MEDIANA',
    MEDIANPOOL: 'MEDIANPOOL',
    MID: 'EXTRAE',
    MIN: 'MIN',
    MINA: 'MINA',
    MINUTE: 'MINUTO',
    MIRR: 'TIRM',
    MMULT: 'MMULT',
    MOD: 'RESIDUO',
    MONTH: 'MES',
    NA: 'NOD',
    NETWORKDAYS: 'DIAS.LAB',
    'NETWORKDAYS.INTL': 'DIAS.LAB.INTL',
    NOMINAL: 'TASA.NOMINAL',
    NOT: 'NO',
    NOW: 'AHORA',
    NPER: 'NPER',
    NPV: 'VNA',
    OCT2BIN: 'OCT.A.BIN',
    OCT2DEC: 'OCT.A.DEC',
    OCT2HEX: 'OCT.A.HEX',
    ODD: 'REDONDEA.IMPAR',
    OFFSET: 'DESREF',
    OR: 'O',
    PDURATION: 'PDURATION',
    PI: 'PI',
    PMT: 'PAGO',
    PRODUCT: 'PRODUCTO',
    POWER: 'POTENCIA',
    PPMT: 'PAGOPRIN',
    PROPER: 'NOMPROPIO',
    PV: 'VA',
    RADIANS: 'RADIANES',
    RAND: 'ALEATORIO',
    RATE: 'TASA',
    REPLACE: 'REEMPLAZAR',
    REPT: 'REPETIR',
    RIGHT: 'DERECHA',
    ROUND: 'REDONDEAR',
    ROUNDDOWN: 'REDONDEAR.MENOS',
    ROUNDUP: 'REDONDEAR.MAS',
    ROW: 'FILA',
    ROWS: 'FILAS',
    RRI: 'RRI',
    SEARCH: 'HALLAR',
    SEC: 'SEC',
    SECH: 'SECH',
    SECOND: 'SEGUNDO',
    SHEET: 'HOJA',
    SHEETS: 'HOJAS',
    SIN: 'SENO',
    SINH: 'SENOH',
    SLN: 'SLN',
    SPLIT: 'SPLIT',
    SQRT: 'RAIZ',
    STDEVA: 'DESVESTA',
    'STDEV.P': 'DESVEST.P',
    STDEVPA: 'DESVESTPA',
    'STDEV.S': 'DESVEST.M',
    SUBSTITUTE: 'SUSTITUIR',
    SUBTOTAL: 'SUBTOTALES',
    SUM: 'SUMA',
    SUMIF: 'SUMAR.SI',
    SUMIFS: 'SUMAR.SI.CONJUNTO',
    SUMPRODUCT: 'SUMAPRODUCTO',
    SUMSQ: 'SUMA.CUADRADOS',
    SWITCH: '',
    SYD: 'SYD',
    T: 'T',
    TAN: 'TAN',
    TANH: 'TANH',
    TBILLEQ: 'LETRA.DE.TEST.EQV.A.BONO',
    TBILLPRICE: 'LETRA.DE.TES.PRECIO',
    TBILLYIELD: 'LETRA.DE.TES.RENDTO',
    TEXT: 'TEXTO',
    TIME: 'NSHORA',
    TIMEVALUE: 'HORANUMERO',
    TODAY: 'HOY',
    TRANSPOSE: 'TRANSPONER',
    TRIM: 'ESPACIOS',
    TRUE: 'VERDADERO',
    TRUNC: 'TRUNCAR',
    UNICHAR: 'UNICHAR',
    UNICODE: 'UNICODE',
    UPPER: 'MAYUSC',
    VARA: 'VARA',
    'VAR.P': 'VAR.P',
    VARPA: 'VARPA',
    'VAR.S': 'VAR.S',
    VLOOKUP: 'BUSCARV',
    WEEKDAY: 'DIASEM',
    WEEKNUM: 'NUM.DE.SEMANA',
    WORKDAY: 'DIA.LAB',
    'WORKDAY.INTL': 'DIA.LAB.INTL',
    XNPV: 'VNA.NO.PER',
    XOR: 'XOR',
    YEAR: 'AÑO',
    YEARFRAC: 'FRAC.AÑO',
    'HF.ADD': 'HF.ADD',
    'HF.CONCAT': 'HF.CONCAT',
    'HF.DIVIDE': 'HF.DIVIDE',
    'HF.EQ': 'HF.EQ',
    'HF.GT': 'HF.GT',
    'HF.GTE': 'HF.GTE',
    'HF.LT': 'HF.LT',
    'HF.LTE': 'HF.LTE',
    'HF.MINUS': 'HF.MINUS',
    'HF.MULTIPLY': 'HF.MULTIPLY',
    'HF.NE': 'HF.NE',
    'HF.POW': 'HF.POW',
    'HF.UMINUS': 'HF.UMINUS',
    'HF.UNARY_PERCENT': 'HF.UNARY_PERCENT',
    'HF.UPLUS': 'HF.UPLUS',
    VAR: 'VAR',
    VARP: 'VARP',
    STDEV: 'DESVEST',
    STDEVP: 'DESVESTP'
  },
  langCode: 'esES',
  ui: {
    NEW_SHEET_PREFIX: 'Sheet'
  }
};
export default dictionary;