/**
 * @license
 * Copyright (c) 2020 Handsoncode. All rights reserved.
 */
import { SimpleCellAddress } from './Cell';
import { InterpreterValue } from './interpreter/InterpreterValue';
import { Matrix } from './Matrix';
export interface CellValueChange {
    sheet: number;
    row: number;
    col: number;
    value: InterpreterValue;
}
export interface ChangeExporter<T> {
    exportChange: (arg: CellValueChange) => T;
}
export declare type ChangeList = CellValueChange[];
export declare class ContentChanges {
    static empty(): ContentChanges;
    private changes;
    addAll(other: ContentChanges): ContentChanges;
    addMatrixChange(newValue: Matrix, address: SimpleCellAddress): void;
    addChange(newValue: InterpreterValue, address: SimpleCellAddress): void;
    add(...change: ChangeList): void;
    exportChanges<T>(exporter: ChangeExporter<T>): T[];
    getChanges(): ChangeList;
    isEmpty(): boolean;
    private addSingleCellValue;
}
