/**
 * @license
 * Copyright (c) 2020 Handsoncode. All rights reserved.
 */
import { AbsoluteCellRange } from '../AbsoluteCellRange';
import { InternalNoErrorScalarValue, InternalScalarValue, SimpleCellAddress } from '../Cell';
import { Config } from '../Config';
import { DependencyGraph } from '../DependencyGraph';
import { Matrix } from '../Matrix';
import { ColumnSearchStrategy } from './SearchStrategy';
import { ColumnsSpan } from '../Span';
import { AdvancedFind } from './AdvancedFind';
export declare class ColumnBinarySearch extends AdvancedFind implements ColumnSearchStrategy {
    protected dependencyGraph: DependencyGraph;
    private config;
    constructor(dependencyGraph: DependencyGraph, config: Config);
    add(value: InternalScalarValue | Matrix, address: SimpleCellAddress): void;
    remove(value: InternalScalarValue | Matrix | null, address: SimpleCellAddress): void;
    change(oldValue: InternalScalarValue | Matrix | null, newValue: InternalScalarValue | Matrix, address: SimpleCellAddress): void;
    addColumns(columnsSpan: ColumnsSpan): void;
    removeColumns(columnsSpan: ColumnsSpan): void;
    removeSheet(sheetId: number): void;
    moveValues(sourceRange: IterableIterator<[InternalScalarValue, SimpleCellAddress]>, toRight: number, toBottom: number, toSheet: number): void;
    removeValues(range: IterableIterator<[InternalScalarValue, SimpleCellAddress]>): void;
    destroy(): void;
    find(key: InternalNoErrorScalarValue, range: AbsoluteCellRange, sorted: boolean): number;
}
