/**
 * @license
 * Copyright (c) 2020 Handsoncode. All rights reserved.
 */
/**
* This is a class for detailed error messages across HyperFormula.
*
* @since 0.2.0
*/
export declare class ErrorMessage {
    static DistinctSigns: string;
    static WrongArgNumber: string;
    static EmptyArg: string;
    static MatrixDimensions: string;
    static ValueSmall: string;
    static ValueLarge: string;
    static BadCriterion: string;
    static RangeManySheets: string;
    static CellRangeExpected: string;
    static ScalarExpected: string;
    static NumberCoercion: string;
    static NumberExpected: string;
    static IntegerExpected: string;
    static BadMode: string;
    static DateBounds: string;
    static OutOfSheet: string;
    static WrongType: string;
    static NaN: string;
    static EqualLength: string;
    static Negative: string;
    static NotBinary: string;
    static NotOctal: string;
    static NotHex: string;
    static EndStartPeriod: string;
    static CellRefExpected: string;
    static BadRef: string;
    static NumberRange: string;
    static ValueNotFound: string;
    static ValueBaseLarge: string;
    static ValueBaseSmall: string;
    static ValueBaseLong: string;
    static NegativeLength: string;
    static PatternNotFound: string;
    static MatrixParams: string;
    static OneValue: string;
    static TwoValues: string;
    static IndexBounds: string;
    static IndexLarge: string;
    static Formula: string;
    static NegativeCount: string;
    static ParseError: string;
    static SheetRef: string;
    static MatrixFunction: string;
    static PeriodLong: string;
    static InvalidDate: string;
    static BitshiftLong: string;
    static EmptyString: string;
    static LengthBounds: string;
    static NegativeTime: string;
    static NoDefault: string;
    static Selector: string;
    static StartEndDate: string;
    static IncorrectDateTime: string;
    static CharacterCodeBounds: string;
    static NonZero: string;
    static LessThanOne: string;
    static WeekendString: string;
    static FunctionName: (arg: string) => string;
    static NamedExpressionName: (arg: string) => string;
    static LicenseKey: (arg: string) => string;
}
