/**
 * @license
 * Copyright (c) 2020 Handsoncode. All rights reserved.
 */
import { InternalScalarValue, SimpleCellAddress } from '../../Cell';
import { ProcedureAst } from '../../parser';
import { ArgumentTypes, FunctionPlugin } from './FunctionPlugin';
export declare class BitShiftPlugin extends FunctionPlugin {
    static implementedFunctions: {
        BITLSHIFT: {
            method: string;
            parameters: ({
                argumentType: ArgumentTypes;
                minValue: number;
                maxValue?: undefined;
            } | {
                argumentType: ArgumentTypes;
                minValue: number;
                maxValue: number;
            })[];
        };
        BITRSHIFT: {
            method: string;
            parameters: ({
                argumentType: ArgumentTypes;
                minValue: number;
                maxValue?: undefined;
            } | {
                argumentType: ArgumentTypes;
                minValue: number;
                maxValue: number;
            })[];
        };
    };
    bitlshift(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    bitrshift(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
}
