/**
 * @license
 * Copyright (c) 2020 Handsoncode. All rights reserved.
 */
import { InternalScalarValue, SimpleCellAddress } from '../../Cell';
import { ProcedureAst } from '../../parser';
import { ArgumentTypes, FunctionPlugin } from './FunctionPlugin';
export declare class BitwiseLogicOperationsPlugin extends FunctionPlugin {
    static implementedFunctions: {
        BITAND: {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
                minValue: number;
            }[];
        };
        BITOR: {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
                minValue: number;
            }[];
        };
        BITXOR: {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
                minValue: number;
            }[];
        };
    };
    bitand(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    bitor(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    bitxor(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
}
