/**
 * @license
 * Copyright (c) 2020 Handsoncode. All rights reserved.
 */
import { InternalScalarValue, SimpleCellAddress } from '../../Cell';
import { ProcedureAst } from '../../parser';
import { ArgumentTypes, FunctionPlugin } from './FunctionPlugin';
export declare class CodePlugin extends FunctionPlugin {
    static implementedFunctions: {
        CODE: {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        UNICODE: {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
    };
    code(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    unicode(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
}
