/**
 * @license
 * Copyright (c) 2020 Handsoncode. All rights reserved.
 */
import { InternalScalarValue, SimpleCellAddress } from '../../Cell';
import { ProcedureAst } from '../../parser';
import { ArgumentTypes, FunctionPlugin } from './FunctionPlugin';
export declare class ErrorFunctionPlugin extends FunctionPlugin {
    static implementedFunctions: {
        ERF: {
            method: string;
            parameters: ({
                argumentType: ArgumentTypes;
                optionalArg?: undefined;
            } | {
                argumentType: ArgumentTypes;
                optionalArg: boolean;
            })[];
        };
        ERFC: {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
    };
    erf(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    erfc(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
}
