/**
 * @license
 * Copyright (c) 2020 Handsoncode. All rights reserved.
 */
import { InternalScalarValue, SimpleCellAddress } from '../../Cell';
import { ProcedureAst } from '../../parser';
import { ArgumentTypes, FunctionPlugin } from './FunctionPlugin';
export declare function findNextOddNumber(arg: number): number;
export declare function findNextEvenNumber(arg: number): number;
export declare class RoundingPlugin extends FunctionPlugin {
    static implementedFunctions: {
        ROUNDUP: {
            method: string;
            parameters: ({
                argumentType: ArgumentTypes;
                defaultValue?: undefined;
            } | {
                argumentType: ArgumentTypes;
                defaultValue: number;
            })[];
        };
        ROUNDDOWN: {
            method: string;
            parameters: ({
                argumentType: ArgumentTypes;
                defaultValue?: undefined;
            } | {
                argumentType: ArgumentTypes;
                defaultValue: number;
            })[];
        };
        ROUND: {
            method: string;
            parameters: ({
                argumentType: ArgumentTypes;
                defaultValue?: undefined;
            } | {
                argumentType: ArgumentTypes;
                defaultValue: number;
            })[];
        };
        TRUNC: {
            method: string;
            parameters: ({
                argumentType: ArgumentTypes;
                defaultValue?: undefined;
            } | {
                argumentType: ArgumentTypes;
                defaultValue: number;
            })[];
        };
        INT: {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        EVEN: {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        ODD: {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        CEILING: {
            method: string;
            parameters: ({
                argumentType: ArgumentTypes;
                defaultValue?: undefined;
            } | {
                argumentType: ArgumentTypes;
                defaultValue: number;
            })[];
        };
    };
    roundup(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    rounddown(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    round(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    trunc(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    intFunc(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    even(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    odd(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    ceiling(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
}
