/**
 * @license
 * Copyright (c) 2020 Handsoncode. All rights reserved.
 */
import { InternalScalarValue, SimpleCellAddress } from '../../Cell';
import { ProcedureAst } from '../../parser';
import { ArgumentTypes, FunctionPlugin } from './FunctionPlugin';
export declare class SimpleArithmerticPlugin extends FunctionPlugin {
    static implementedFunctions: {
        'HF.ADD': {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        'HF.CONCAT': {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        'HF.DIVIDE': {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        'HF.EQ': {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        'HF.GT': {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        'HF.GTE': {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        'HF.LT': {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        'HF.LTE': {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        'HF.MINUS': {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        'HF.MULTIPLY': {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        'HF.NE': {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        'HF.POW': {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        'HF.UMINUS': {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        'HF.UNARY_PERCENT': {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
        'HF.UPLUS': {
            method: string;
            parameters: {
                argumentType: ArgumentTypes;
            }[];
        };
    };
    add(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    concat(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    divide(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    eq(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    gt(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    gte(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    lt(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    lte(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    minus(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    multiply(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    ne(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    pow(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    uminus(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    upercent(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
    uplus(ast: ProcedureAst, formulaAddress: SimpleCellAddress): InternalScalarValue;
}
